
/****** Object : Table [dbo].[Perfcounter] Copyright TECK SYSTEM SOFT 2024 One ******/

UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[PerfCounter] SET [Insert_Date] = '' WHERE [Insert_Date] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[PerfCounter] SET [Customer] = '' WHERE [Customer] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[PerfCounter] SET [Site] = '' WHERE [Site] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[PerfCounter] SET [Manager] = '' WHERE [Manager] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[PerfCounter] SET [Severity] = '' WHERE [Severity] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[PerfCounter] SET [Dashboard] = '' WHERE [Dashboard] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[PerfCounter] SET [Domain] = '' WHERE [Domain] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[PerfCounter] SET [Computer] = '' WHERE [Computer] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[PerfCounter] SET [Perfmon] = '' WHERE [Perfmon] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[PerfCounter] SET [Value] = '' WHERE [Value] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[PerfCounter] SET [Mode] = '' WHERE [Mode] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[PerfCounter] SET [Alarm] = '' WHERE [Alarm] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[PerfCounter] SET [Availability] = '' WHERE [Availability] IS NULL

INSERT INTO [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilityPerfCounter] 
([Insert_Date]
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain]
      ,[Computer]
      ,[Perfmon]
      ,[Value] 
      ,[Mode] 
      ,[Alarm]
      ,[Availability]
)

SELECT  
[Insert_Date]
       ,[Customer]
       ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain] 
      ,[Computer]
      ,[Perfmon]
      ,[Value] 
      ,[Mode] 
      ,[Alarm]
      ,CONVERT(nvarchar(10),[Availability])


FROM

(SELECT DISTINCT CONVERT(nvarchar(25),[Insert_Date]) + '-' + [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Perfmon] + '-' + [Alarm] + '-' + [Value] + '-' + CONVERT(nvarchar(10),[Availability]) AS SEARCH_STRING
	   ,[Insert_Date] /* Add for test purpose only */
      ,[Customer]
      ,[Site]
      ,[Manager]
      ,[Severity]
      ,[Dashboard]
      ,[Domain]
      ,[Computer]
      ,[Perfmon]
      ,[Value] 
      ,[Mode]
      ,[Alarm]
      ,[Availability] 

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[PerfCounter]
WHERE [Availability] = '1' AND CONVERT(nvarchar(25),[Insert_Date]) + '-' + [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Perfmon] + '-' + [Alarm]  + '-' + [value] + '-' + CONVERT(nvarchar(10),[Availability])  NOT IN 

(SELECT DISTINCT CONVERT(nvarchar(25),[Insert_Date]) + '-' + [Customer] + '-' + [Site] + '-' + [Domain] + '-' + [Computer] + '-' + [Perfmon] + '-' + [Alarm]  + '-' + [Value]+ '-' + CONVERT(nvarchar(10),[Availability]) as SEARCH_STRING 
FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilityPerfCounter]) ) TBL 
WHERE [Availability] = 1

/****** Object : UPDATE existing entries with the lastest values ******/

UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilityPerfCounter] 
SET  [Value] = REQUEST.[Value],
     [Alarm] = REQUEST.[Alarm],
     [Availability] = REQUEST.[Availability]
     /* [Insert_Date] = REQUEST.[Insert_Date] -- Last UPDATE time 24/03/2017 */

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[AvailabilityPerfCounter] PERFS,

/****** Object : Select values ******/

(SELECT TEMP_JOIN.[Perfmon_ID],
TEMP_JOIN.[Insert_Date],
TEMP_JOIN.[Customer],
TEMP_JOIN.[Site],
TEMP_JOIN.[Domain],
TEMP_JOIN.[Computer],
TEMP_JOIN.[Perfmon],
TEMP_JOIN.[Mode],
TEMP_JOIN.[Value],
TEMP_JOIN.[Alarm],
TEMP_JOIN.[Availability]

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[PerfCounter] TEMP
INNER JOIN  [Monitorpack_GuardReportsMonitorpack].[dbo].[PerfCounter] TEMP_JOIN 
ON TEMP_JOIN.[Mode] = TEMP.[Mode]

WHERE 
TEMP.[Customer] = TEMP_JOIN .[Customer] AND
TEMP.[Site] = TEMP_JOIN .[Site] AND
TEMP.[Domain] = TEMP_JOIN .[Domain] AND
TEMP.[Computer] = TEMP_JOIN .[Computer] AND
TEMP.[Perfmon] =  TEMP_JOIN .[Perfmon] AND
TEMP.[Mode] = TEMP_JOIN .[Mode] AND
TEMP.[Value] = TEMP_JOIN .[Value] AND
TEMP.[Availability]=TEMP_JOIN.[Availability]

GROUP BY
TEMP_JOIN.[Perfmon_ID],
TEMP_JOIN.[Insert_Date],
TEMP_JOIN.[Customer],
TEMP_JOIN.[Site],
TEMP_JOIN.[Domain],
TEMP_JOIN.[Computer],
TEMP_JOIN.[Perfmon],
TEMP_JOIN.[Mode],
TEMP_JOIN.[Value],
TEMP_JOIN.[Alarm],
TEMP_JOIN.[Availability]

HAVING max(TEMP.Perfmon_ID) = TEMP_JOIN.[Perfmon_ID]) AS REQUEST

WHERE
PERFS.[Customer] = REQUEST.[Customer]
AND PERFS.[Site] = REQUEST.[Site]   
AND PERFS.[Domain] = REQUEST.[Domain]
AND PERFS.[Computer] = REQUEST.[Computer]
AND PERFS.[Alarm] = REQUEST.[Alarm]
AND PERFS.[Value] = REQUEST.[Value]
AND PERFS.[Availability] = REQUEST.[Availability]

/****** Object : Clean once availability database is updated ******/

TRUNCATE TABLE [Monitorpack_GuardReportsMonitorpack].[dbo].[PerfCounterTemp]      